package com.accenture.techlabs.assist.profile;

/**
 * @author chen.fu
 * 
 * An interface for both data providers and consumers.  The implementer should be a central
 * data repository that are thread safe.  The biggest concern is that the data producer clients
 * should <bold>not</bold> be blocked, at least not too long to cause the data profiler to stall
 * the running application.
 * 
 */
interface IDataManager {

	/**
	 * insert a line of text into the profile repository
	 * @param data
	 */
	void insertLine(String data);

	/**
	 * return a line of text from the profile repository
	 * caller thread may be blocked if there's no text in the repository
	 * @return
	 * @throws InterruptedException 
	 */
	String getNextLine() throws InterruptedException;

	/**
	 * Terminate all the thread that are waiting to get further result.
	 */
	void shutDown();
}
