package com.accenture.techlabs.assist.profile;

import java.util.Properties;

import org.apache.jmeter.NewDriver;
import org.apache.log4j.Logger;

public class ProfRepository {
	
	// QI
	private static final Logger logger = Logger.getLogger(ProfRepository.class);
	
	static final String profiledir = "C:\\Research\\workspace_AFOCMS\\JMeterScript\\RepositoryData"; // TODO! SHOULD BE CONFIG PARAMETER
	static final int port = 10525; // TODO! SHOULD BE CONFIG PARAMETER

	public static IDataManager repository = null;
	private static boolean started = false;

	public static void start() {
		//QI
//		logger.info("profRepository start!");
		
		if (!started) {
			ProfilerAdaptor.startup();
			repository = new QueueDataManager();
			started = true;
		}
	}

	public static boolean profilerActive() {
		return ProfilerAdaptor.profilerActive();
	}

	public static void mockStart(String repository_dir) {
		repository = new MockDataManager();
		((MockDataManager) repository).setRepositoryDirname(repository_dir);
	}

	public static void shutdown() {
		ProfilerAdaptor.shutdown();
		repository.shutDown();
	}

	public static boolean started(){
		return started;
	}

	/**
	 * Special profile lines that mark the starting or end point of profile,
	 * should take the form of tag followed by the name or id of a profile.
	 */
	public final static String profileStartTag = "START_PROFILE";
	public final static String profileEndTag = "END_PROFILE";
	public final static String loopStartTag = "START_LOOP";
	public final static String loopEndTag = "END_LOOP";

	public static void startProfile() {
		//logger.info("insertTag START_PROFILE into profile!"); //QI
		insertTag(profileStartTag);		
	}
	
	public static void endProfile(){
		insertTag(profileEndTag);
	}

	public static void startProfile(String id) {
		//logger.info("insertTag START_PROFILE into profile with thread ID"); //QI
		insertTag(profileStartTag + "_" + id);
	}

	public static void endProfile(String id) {
		insertTag(profileEndTag + "_" + id);
	}

	public static void startLoopTag(int id) {
		insertTag(loopStartTag + "_" + id);
	}

	public static void endLoopTag(int id) {
		insertTag(loopEndTag + "_" + id);
	}

	public static void insertTag(String tag) {
		repository.insertLine(tag);
	}

	public static void recordException(String ex){
		repository.insertLine("EXCEPTION_START");
		repository.insertLine(ex);
		repository.insertLine("EXCEPTION_END");
	}

	public static String getProfileLine() throws InterruptedException {
		return repository.getNextLine();

	}

}
