package com.accenture.techlabs.assist.profile;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;

import org.apache.jmeter.NewDriver;
import org.apache.log4j.Logger;

public class ProfilerAdaptor extends Thread {

	// QI
	public static int num = 0;
	private static final Logger logger = Logger.getLogger(ProfilerAdaptor.class);
	
	private static boolean active = false;
	private static boolean stoprequested = false;
	private static ServerSocket ssocket = null;

	// HOW TO ENSURE THERE'S ONLY ONE COPY OF THIS THREAD RUNNING?
	private static final ProfilerAdaptor instance = new ProfilerAdaptor();

	private ProfilerAdaptor() {
	}

	public static void startup() {
		instance.start();
	}

	public static void shutdown() {
		stoprequested = true;
		try {
			ssocket.close();
		} catch (IOException e) {
			// Ignore exception when we are trying to get out anyway
		}
		instance.interrupt();
	}

	public static boolean profilerActive() {
		return active;
	}

	@Override
	public void run() {

		Socket conn = null;
		BufferedReader profilereader = null;
		String profileline = null;

		try {
			ssocket = new ServerSocket(ProfRepository.port);
		} catch (IOException e) {
			System.err
					.println("Can not initialize server socket to communicate with profiler! Port number: "
							+ ProfRepository.port);
			e.printStackTrace();
			return;
		}

		try {
			for (;;) {
				System.out.println("Waiting for connection from profiler at port: "
								+ ProfRepository.port);
				try {
					conn = ssocket.accept();
					System.out.println("SSOCKET Connection accepted"); //QI
//					logger.info("SSOCKET Connection accepted!"); //QI
					profilereader = new BufferedReader(new InputStreamReader(
							conn.getInputStream()));
				} catch (IOException e) {
					System.err.println("Error Connecting to Profiler!");
					e.printStackTrace();
					return;
				}
				active = true;
				try {
					while ((profileline = profilereader.readLine()) != null) {
						// Write to profileRepository
						ProfRepository.insertTag(profileline);
						//TEST. QI
//						if (profileline.contains("endProfile")) {
//							System.out.println("Enter the endProfile page successfully!");
//						}
						if (profileline.contains("REQENT")) {
							num ++;
						}
						if (stoprequested) {
							return;
						}
					}
				} catch (IOException e) {
					System.err
							.println("Error while receiving data from profiler!");
					e.printStackTrace();
				}
				if (stoprequested) {
					return;
				}

				active = false;
				System.err.println("Lost connection with profiler");
			}
		} finally {
			active = false;
			if (ssocket != null)
				try {
					ssocket.close();
				} catch (IOException e) {
				}
		}
	}

}
