package com.accenture.techlabs.assist.profile;

import java.io.IOException;
import java.io.PrintStream;
import java.net.Socket;
import java.util.Random;

public class SynTest {

	/**
	 * @param args
	 * @throws InterruptedException
	 * @throws IOException 
	 */
	public static void main(String[] args) throws InterruptedException, IOException {

		ProfRepository.start();
		Thread reader = new Thread() {
			public void run() {
				System.out.println("Reader Started!");
				try {
					for (int i = 0; i < 900000; i++) {
						String data = ProfRepository.getProfileLine();// May block
						System.out.println("Output: " + data);
					}
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		};
		/**
		 * // This reader thread simulate a running Analyzer that read the profile information constantly
		 */
		reader.start(); 

		/**
		 * This part simulate a running application with profilers hooked in, which writes to the profile repository through network.
		 */
		Random r = new Random(0x284cf76f1e9L);
		// Connect to Profiler Adaptor and send the line using socket
		Socket socket = null;
		PrintStream prt = null;
		try {
			Thread.yield();
			socket = new Socket("localhost", ProfRepository.port);
			prt = new PrintStream(socket.getOutputStream());
		} catch (Exception e) {
			System.err.println("Can not connect to profiler!\n");
			e.printStackTrace();
			System.exit(1);
		}
		for (int i = 0; i <= 100000; i++) {
			int rand = r.nextInt();
			prt.println("Rand Number #" + i + ": " + rand);
			if ((i % 10000 == 0)) {
				ProfRepository.insertTag(ProfRepository.profileEndTag);
			}
			Thread.yield();
		}

		socket.close();
		ProfRepository.shutdown();
		System.out.println("Waiting for reader to complete.");
		reader.join();

	}

}
