package forepost;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.*;


public class ArffManager 
{
	public static enum KINDOFDATA {IMS, INPUTPARAMS };
	protected Writer output = null;
	protected String arffFileName = null;
	protected final String ATTRIBUTE = "@attribute ";
	protected LinkedList <ProfileParser> profiles = null;
	protected LinkedList<String> Classes = null;

	public LinkedList<String> getClasses() {
		return Classes;
	}

	public void setClasses(LinkedList<String> classes) {
		Classes = classes;
	}

	public ArffManager(String arffFileName) throws Exception{
		if( arffFileName == null ){
			throw new Exception("ARFF file name is null");
		}
		this.arffFileName = arffFileName;
		
	}

	public ArffManager(String arffFileName, LinkedList <ProfileParser> table) throws Exception
	{
		if( arffFileName == null ){
			throw new Exception("ARFF file name is null");
		}

		if( table == null ){
			throw new Exception("Profiles table object is null");
		}
		
		this.arffFileName = arffFileName;
		profiles = table;		
	}
	
	public void CreateArffData(String relationName) throws Exception
	{
		if( relationName == null ){
			throw new Exception("Relation name string cannot be null");
		}
	
		try {
			output = new BufferedWriter(new FileWriter(arffFileName));
			output.write( "@relation " + relationName + "\n\n" );
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	
}
