package forepost;
import java.util.*;
import java.io.*;

public class Components 
{
	Hashtable<Integer, LinkedList<MethodExecTimes>> signals = new Hashtable<Integer, LinkedList<MethodExecTimes>>();

	LinkedList<MethodExecTimes>Methods = null;
	LinkedList<MethodExecTimes> methodExec = null;
	int component = 0;
	
	public Components(LinkedList<MethodExecTimes>Methods, double[][] icm ) throws Exception
	{
		this.Methods = Methods;
		if( Methods == null || icm == null ) throw new Exception( "Cannot process null parameters" );
		for( int i = 0; i < icm.length; i++ ){
			methodExec = new LinkedList<MethodExecTimes>();
			component = i;
			double [] ar = icm[i].clone();
			Arrays.sort(ar);
			for( int j = icm[i].length-1; j >=0; j-- ){
				methodExec.addAll( FindIndex(ar[j], icm[i], i) );
			}
			signals.put(Integer.valueOf(i), methodExec);//WHY QI
		}		
	}

	private LinkedList<MethodExecTimes> FindIndex(double d, double[] es, int component) throws Exception 
	{
		if( es == null ) throw new Exception( "Cannot process null parameters" );
		LinkedList<MethodExecTimes> methodExec = new LinkedList<MethodExecTimes>(); 

		for( int i = 0; i < es.length; i++ ){
			if( es[i] == d ){

				if (Methods.size() <= i) {
					System.out.println("Methods.size(): " + Methods.size());
					System.out.println("es.length: " + es.length);
				}

				MethodExecTimes mExec = Methods.get(i);
				mExec.AddSignal(component, d);
				methodExec.add(mExec);
			}
		}

		return methodExec;
	}

	void PrintAll(String fileName)throws Exception 
	{
		if( fileName == null ) throw new Exception( "File name is null" );
		try 
		{
			Writer output = null;
			File file = new File(fileName);
			output = new BufferedWriter(new FileWriter(file));
	
			Enumeration <Integer> e = signals.keys();
			while(e.hasMoreElements()) {
				Integer comp = e.nextElement();
				output.write("===================== S I G N A L #" + String.valueOf(comp.intValue()) + " =====================\n");
				methodExec = signals.get(comp);
				for( int i = 0; i < methodExec.size(); i++ ){
					MethodExecTimes met = methodExec.get(i);
					String outStr = null;
					if( met.GetSignal(comp.intValue()) > 0 ){
						outStr = "Package: " + met.getContainer() + ", Method: " + met.getName() +"\n";
						output.write(outStr);
						outStr = "Signal: " + met.GetSignal(comp.intValue()) + "\n";
						output.write(outStr);
					}
				}
				output.write("\n\n");
			}
			output.flush();
		    output.close();
		} catch( Exception e ){
			e.printStackTrace();
			throw new Exception( "exception when writing signals" );
		}
	}

	public Hashtable<Integer, LinkedList<MethodExecTimes>> getSignals() {
		return signals;
	}
	
	public void CrossRef(Components ic, double threshold, String xmlFileName) throws Exception
	{
		if( ic == null ) throw new Exception( "The counterpart component object is null" );
		Hashtable<Integer, LinkedList<MethodExecTimes>> otherSignals = ic.getSignals();
		if( otherSignals == null ) throw new Exception( "The signals object is null" );
		
		try
		{
			String keyStartElement = "<Signal_", keyEndElement = "</Signal_", endTag = ">\n", outStr = null;
			String startMethod = "<Method Container=\"", midMethodName = "\" Name=\"", midMethodSignal = "\" Signal=\"", endMethodLine = "\">\n", endMethod = "</Method>\n";
			Writer output = null;
			File file = new File(xmlFileName);
			output = new BufferedWriter(new FileWriter(file));
			output.write("<Signals>\n");
			Enumeration <Integer> e = signals.keys();
			while(e.hasMoreElements()) {
				Integer comp = e.nextElement();
				outStr = keyStartElement + String.valueOf(comp.intValue()) + endTag;
				output.write(outStr);
				methodExec = signals.get(comp);
				for( int i = 0; i < methodExec.size(); i++ ){
					MethodExecTimes met = methodExec.get(i);
					if( met.GetSignal(comp.intValue()) > threshold ){
						MethodExecTimes found = ic.FindMethod(met);
						if( found != null){
							outStr = startMethod + met.getContainer().replace('<', '_').replace('>', '_') + midMethodName + met.getName().replace('<', '_').replace('>', '_') + midMethodSignal + met.GetSignal(comp.intValue()) + endMethodLine;
							output.write(outStr);
							for( int x = 0; x < signals.size(); x++ ){
								outStr = keyStartElement + String.valueOf(x) + ">" + String.valueOf(found.GetSignal(x));
								output.write(outStr);
								outStr = keyEndElement + String.valueOf(x) + endTag;
								output.write(outStr);
							}
							outStr = endMethod;
							output.write(outStr);
						}
					}
				}
				outStr = keyEndElement + String.valueOf(comp.intValue()) + endTag;
				output.write(outStr);
			}
			output.write("</Signals>\n");
			output.flush();
		    output.close();
		} catch( Exception e ){
			e.printStackTrace();
			throw new Exception( "exception when writing signals" );
		}	
	}

	public MethodExecTimes FindMethod(MethodExecTimes met) throws Exception 
	{
		if( met == null ) throw new Exception( "The method parameter object is null" );
		MethodExecTimes mExec = null;
		for( int i = 0; i < Methods.size(); i++ ){
			mExec = Methods.get(i);
			if(mExec != null){
				if( met.getContainer().compareTo(mExec.getContainer()) == 0 && met.getName().compareTo(mExec.getName()) == 0 ){
					return(mExec);
				}
			}
		}
		return null;
	}
}
