package forepost;
import java.awt.BorderLayout;
import java.io.BufferedReader;
import java.io.FileReader;
 
import weka.classifiers.trees.J48;
import weka.core.Instances;
import weka.gui.treevisualizer.PlaceNode2;
import weka.gui.treevisualizer.TreeVisualizer;

public class DecisionTreeVisualizer {
	private J48 cls = new J48();
	private Instances data = null;
	private javax.swing.JFrame jf = null; 
	
	public DecisionTreeVisualizer( String arffFile ) throws Exception
	{
		if( arffFile == null ) throw new Exception("ARFF file name cannot be null");
	     data = new Instances(new BufferedReader(new FileReader(arffFile)));
	}
	
	public void Reset( String arffFile ) throws Exception
	{
		if( arffFile == null ) throw new Exception("ARFF file name cannot be null");
	     data = new Instances(new BufferedReader(new FileReader(arffFile)));
	     cls = new J48();
	     if( jf != null )
	     {
	    	 jf.dispose();
	    	 jf = null;
	     }
	}

    public void Classify() throws Exception 
    {
    	data.setClassIndex(data.numAttributes() - 1);
    	cls.setNumFolds(10);
    	cls.setDebug(true);
    	cls.buildClassifier(data);
//    	System.out.println("Full tree\n");
//    	System.out.println(cls.toString());
    	System.out.println(cls.toSource("good"));
//    	System.out.println("Summary tree\n");
//    	System.out.println(cls.toSummaryString());
    }

    public void Visualize() throws Exception 
    {
    	jf = new javax.swing.JFrame("FOREPOST Decision Tree");
    	jf.setSize(500,400);
    	jf.getContentPane().setLayout(new BorderLayout());
    	TreeVisualizer tv = new TreeVisualizer(null, cls.graph(), new PlaceNode2());
    	jf.getContentPane().add(tv, BorderLayout.CENTER);
    	jf.addWindowListener(new java.awt.event.WindowAdapter() { 
    			public void windowClosing(java.awt.event.WindowEvent e) {
    				jf.dispose();
    			}
    	});
		 
    	jf.setVisible(true);
    	tv.fitToScreen();
    }
}
