package forepost;
import java.util.*;
import java.util.logging.Level;

public class ExecutionStack {
	Hashtable<String, Stack<MethodCall>> execStack = new Hashtable<String, Stack<MethodCall>>();
	Stack<MethodCall> threadStack = null;
	
	public ExecutionStack() {	
	}
	
	public MethodCall AddMethodCall( String ThreadId, long sTime, Method m ) throws Exception {
//		MethodCall parent = null;
		if( ThreadId == null || m == null ) {
			throw new Exception( "Input parameters are null");
		}
		MethodCall current = new MethodCall(sTime, ThreadId, m);

		threadStack = execStack.get(ThreadId);
		if( threadStack != null ) {
//			if( threadStack.size() > 0 ) {
//				parent = threadStack.peek();
//				if( parent != null ){
//					parent.AddChild(current);
//					current.AddParent(parent);
//				}
//			}
			threadStack.push(current);
			m.AddMethodCall(ThreadId);
//			m.AddMethodCall(ThreadId, current);
		}
		else
		{
			threadStack = new Stack<MethodCall>();
			threadStack.push(current);
			execStack.put(ThreadId, threadStack);
		}

		return( current );
	}

	public void EndMethodCall( String ThreadId, long eTime, Method m ) throws Exception {
		if( ThreadId == null || m == null ) {
			System.out.println( "Input parameters are null");
		}
		else
		{
		
		MethodCall parent = null;
		threadStack = execStack.get(ThreadId);
		if( threadStack == null ) {
			//throw new Exception( "No existing thread on the stack");
//			System.out.println("No existing thread on the stack"); hide_focus
			FPUtility.getLogger().log(Level.SEVERE,"Thread Stack Not Found When Method Exit: "+m.getName());
		}
		else
		{
			if( threadStack.size() <= 0 ){
//				throw new Exception( "No existing method call on the stack");
//				System.out.println("No existing method call on the stack"); hide_focus
				FPUtility.getLogger().log(Level.SEVERE,"Thread Stack Empty When Method Exit: "+m.getName());
				return;
			}
			
			MethodCall mCall = threadStack.peek(); // WHY QI If anything goes wrong in the following branches, we don't want to pop the stack yet
			if( mCall == null ) {
//				throw new Exception( "Unrecoverable error in the method EndMethodCall");
//				System.out.println("Unrecoverable error in the method EndMethodCall"); hide_focus
				FPUtility.getLogger().log(Level.SEVERE,"Curruptted Call Record on Stack When Method Exit: "+m.getName());
				return;
			}
			
			if( !m.Compare(mCall.getMethod()) ) {
//				throw new Exception( "Mismatch with the top method call on the stack: " + mCall.getMethod().getName() + " vs " + m.getName() );
//				System.out.println("Mismatch with the top method call on the stack: " + mCall.getMethod().getName() + " vs " + m.getName());
				FPUtility.getLogger().log(Level.SEVERE,"Mismatch with top method on stack When Method Exit: "+m.getName());
				mCall = null;
				return;
			}
			mCall.Finish(eTime);
			threadStack.pop();//WHY QI
			if( threadStack.size() > 0 ){
				parent = threadStack.peek();
				if( parent != null ){
					parent.ElapsedTime4CallTree(mCall.getElapsedTime());
				}
			}
			mCall = null;
		}
		}
	}

	public void SetDataInfo(String ThreadId, int attrs, int datalen) throws Exception {
		if( ThreadId == null ) {
			throw new Exception( "Input parameters are null");
		}
		
		threadStack = execStack.get(ThreadId);
		if( threadStack != null ) {
			Iterator<MethodCall> mcallit = threadStack.iterator();
			while( mcallit.hasNext() ){
				MethodCall mc = mcallit.next();
				if( mc != null ){
					mc.getMethod().SetDataParams(attrs, datalen); 
				}
			}
		}
	}
	
	
	public void PrintStack(String ThreadId) throws Exception {
		if( ThreadId == null ) {
			throw new Exception( "Input parameters are null");
		}
		
		threadStack = execStack.get(ThreadId);
		if( threadStack != null ) {
//			System.out.println("Stack for thread: " + ThreadId ); hide_focus
			Iterator<MethodCall> mcallit = threadStack.iterator();
			while( mcallit.hasNext() ){
				MethodCall mc = mcallit.next();
				System.out.println("Package: " + mc.getMethod().getContainer() + ", method: " + mc.getMethod().getName() );
			}
		}
	}

	public boolean IsEmpty() {
		if( threadStack != null ){
			return( threadStack.size() == 0 );
		}
		return true;
	}
}
