package forepost;
import java.util.Scanner;
import java.util.logging.Level;

import org.jdesktop.application.Application;

public class FPMainClass {

	public ProfileAnalyzer analyzer = null;
	
	public FPMainClass() {
		try {
			analyzer = new ProfileAnalyzer(FPUtility.getRepository());
			analyzer.startGUI();
			
		} catch (Exception e) {
			e.printStackTrace();
		} 
	}
	
	public void StartAnalyzer() throws Exception
	{
		if( analyzer == null) {
			FPUtility.getLogger().log(Level.SEVERE, "Analyzer object is null");
			return;
		}
		new Thread(analyzer).start();
	}

	public void SuspendAnalyzer() throws Exception
	{
		if( analyzer == null) {
			FPUtility.getLogger().log(Level.SEVERE, "Analyzer object is null");
			return;
		}
		analyzer.Suspend();
	}

	public void ResumeAnalyzer() throws Exception
	{
		if( analyzer == null) {
			FPUtility.getLogger().log(Level.SEVERE, "Analyzer object is null");
			return;
		}
		analyzer.Resume();
	}

	public void Analyzer() throws Exception
	{
		if( analyzer == null) {
			FPUtility.getLogger().log(Level.SEVERE, "Analyzer object is null");
			return;
		}
//		analyzer.Analyze(false);
	}

	public void ShowTree() throws Exception
	{
		if( analyzer == null) {
			FPUtility.getLogger().log(Level.SEVERE, "Analyzer object is null");
			return;
		}
		analyzer.GetInputParamDecisionTree();
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		int number = 0;
		
		FPMainClass mainc = new FPMainClass();
		
		Scanner console = new Scanner(System.in);
		do {
			System.out.println("Type ");
			System.out.println(" 0 to exit;");
			System.out.println(" 1 to start reading data from the repository;");
			System.out.println(" 2 to pause reading data from the repository;");
			System.out.println(" 3 to resume reading data from the repository;");
			System.out.println(" 4 to run rule analysis;");
			System.out.println(" 5 to compute a decision tree;");
			number = console.nextInt();
			try {
				switch(number){
				case 1:
					mainc.StartAnalyzer();
					FPUtility.getLogger().info("started extracting data from the repository");
					break;
				case 2:
					mainc.SuspendAnalyzer();
					FPUtility.getLogger().info("Analyzer is suspended");
					break;
				case 3:
					mainc.ResumeAnalyzer();
					FPUtility.getLogger().info("Analyzer is resumed");
					break;
				case 4:
					mainc.Analyzer();
					FPUtility.getLogger().info("Analyzer is run");
					break;
				case 5:
					mainc.ShowTree();
					break;
				default:
					break;
				}
				
				
			} catch (Exception e) {
				e.printStackTrace();
			}
		} while( number > 0 );
	}

}
