package forepost;
import java.util.*;

public class ImsDataParser extends KVDataParser
{
	private final static String token = "\01\02|\01|\02";
	private int attrs = 0, datalen = 0;
	private int totalAttrs = 0, totalDatalen = 0;

	public int getTotalAttrs() {
		return totalAttrs;
	}

	public int getTotalDatalen() {
		return totalDatalen;
	}

	public int getAttrs() {
		return attrs;
	}

	public int getDatalen() {
		return datalen;
	}

	public ImsDataParser(){
		super();
	}
		
	public void Parse(String imsData) throws Exception
	{
//		System.out.println( "Parsing data string" );
		attrs = 0; 
		datalen = 0;
		if( imsData == null ){
			throw new Exception("Ims string cannot be null");
		}

		String [] entries = imsData.split(token);
		if( entries == null )
			throw new Exception( "String is not tokenized" );

		Table = new Hashtable<String, String>();
		Runs.add(Table);
		
		String key, value;
		for(int i = 0; i < entries.length; i+=2){
			key = entries[i];
			if( key == null || key.length() == 0 ){
				throw new Exception( "A key cannot be null or empty in data" );
			}
			++attrs;
			if( i+1 < entries.length ){
				value = entries[i+1];
			} else {
				value = "";
			}
			if( !(value.length() == 0) ){
				AddUniqueKeyValue(key, value);
				Table.put(key, value);
			}
			datalen += value.length();
//			System.out.println( "Key: " + key + ", value: " + value );
		}

		totalAttrs += attrs;

		totalDatalen += datalen;

		ComputedValues.MAXKEYSUSED += attrs;

		ComputedValues.MAXDATALEN += datalen;
//		System.out.println( "Total keys: " + String.valueOf(ComputedValues.MAXKEYSUSED) + ", value total size: " + String.valueOf(ComputedValues.MAXDATALEN) );
	}
}
