package forepost;
import java.util.*;
import java.io.*;

public class InputsExclusion 
{
	private String iniFileName = null;
	Properties excludeInputs = new Properties();

	public InputsExclusion()
	{
		try {
			iniFileName = FPUtility.getExclusionFile();
			excludeInputs.load(new FileInputStream(iniFileName));
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
	
	public boolean IsExcluded( String screen, String input )
	{
		try{
			String allScreens = null;
			if( screen != null && input != null )
			{
				if( excludeInputs.containsKey(input) )
				{
					allScreens = excludeInputs.getProperty(input);
				}
				else if( excludeInputs.containsKey("*") )
				{
					allScreens = excludeInputs.getProperty("*");
				}
				else {
					return( false );
				}
				if( allScreens.compareToIgnoreCase("*") == 0 ){
					return( true );
				}
				else
				{
					String [] entries = allScreens.split(",");
					if( entries != null ){
						for(int i = 0; i < entries.length; i++){
							if( screen.compareToIgnoreCase(entries[i]) == 0 )
								return( true );
						}
					}
				}
				
			}
		}
		catch (Exception e) {
			System.out.println(e);
		}
		return( false );
	}
}
