package forepost;
import java.util.*;

public class Method implements MethodData {
	private String container = null;
	private String name = null;
	Vector<String> Parameters = null;
	long elapsed = 0;
	int attributes = 0, datalen = 0;
	double elapsedTimeRatio = 0.0;
	
//	Hashtable<String, Vector<MethodCall>> invocations = new Hashtable<String, Vector<MethodCall>>();
	Hashtable<String, Integer> invocations = new Hashtable<String, Integer>();
	
	public Method( String contpckg, String mName ) throws Exception
	{
		if( contpckg == null || mName == null ){
			throw new Exception("Method name or its container name cannot be null");
		}
		container = contpckg;
		name = mName;
	}
	
	public String getContainer(){
		return(container);
	}

	public String getName(){
		return(name);
	}
	
	public boolean Compare( String cont, String mparms ) {
		if( cont == null || mparms == null )
			return(false);
			
		if( cont.compareTo(this.getContainer()) == 0 && mparms.compareTo(this.getName()) == 0 )
			return(true);
		
		return(false);
	}

	public boolean Compare( Method m ) {
		if( m == null )
			return(false);
			
		if( m.getContainer().compareTo(this.getContainer()) == 0 && m.getName().compareTo(this.getName()) == 0 )
			return(true);
		
		return(false);
	}

	public void AddMethodCall( String thread ) throws Exception
	{
		if( thread == null ) {
			throw new Exception( "Input parameters are null");
		}
		Integer vCalls = invocations.get(thread);
		if( vCalls == null ){
			vCalls = new Integer(1);
		}
		else {
			int in = vCalls.intValue();
			vCalls = new Integer(in+1);
		}
		invocations.put( thread, vCalls );
	}
	
//	public void AddMethodCall( String thread, MethodCall mCall ) throws Exception
//	{
//		if( thread == null || mCall == null ) {
//			throw new Exception( "Input parameters are null");
//		}
//		Vector<MethodCall> vCalls = invocations.get(thread);
//		if( vCalls == null ){
//			vCalls = new Vector<MethodCall>();
//			invocations.put( thread, vCalls );
//		}
//		vCalls.add(mCall);
//	}
	
	public void MaxTime(){
		if(elapsed > ComputedValues.MAXTIME){
			ComputedValues.MAXTIME = elapsed;
		}
	}
	
	public double GetElapsedTimeRatio(){
		return( (double)((double)elapsed/(double)ComputedValues.MAXTIME) );
	}
	
	
	
	public long ComputeElapsedTime(){
	//	elapsed = 0;
	//	String threadId;
	//	Set<String> thread = invocations.keySet();
	//	Iterator<String> iter = thread.iterator();
	//	while( iter.hasNext() ) {
	//		threadId = iter.next();
	//		Vector<MethodCall> mCalls = invocations.get(threadId);
	//		for( int i = 0; i < mCalls.size(); i++ ){
	//			MethodCall mc = mCalls.elementAt(i);
	//			elapsed += mc.getElapsedTime();
	//		}
	//	}
		return( elapsed );
	}
	
	public void PrintInfo(){
		long elapsed = 0;
		String threadId;
		String outStr;
		Set<String> thread = invocations.keySet();
		Iterator<String> iter = thread.iterator();
		while( iter.hasNext() ) {
			threadId = iter.next();
			Integer mCalls = invocations.get(threadId);
			outStr = "This method is executed in the thread " + threadId + " " + mCalls.intValue() + " times for the total of " + String.valueOf(elapsed) + " ms";
			System.out.println( outStr );
		}
	}

	public int GetInvocations() {
		int Invocations = 0;
		Set<String> thread = invocations.keySet();
		Iterator<String> iter = thread.iterator();
		while( iter.hasNext() ) {
			String threadId = iter.next();
			Integer mCalls = invocations.get(threadId);
			Invocations += mCalls.intValue();
		}
		return Invocations;
	}

	public int GetThreads() {
		Set<String> thread = invocations.keySet();
		return thread.size();
	}

	public void AddElapsedTime(long elapsed2) {
		elapsed += elapsed2;
	}

	public void SetDataParams(int attrs, int datalen2) 
	{
		attributes += attrs;
		datalen += datalen2;		
//		System.out.println("Method: " + this.getName() + ", attrs: " + String.valueOf(attributes) + ", data: " + String.valueOf(datalen));
	}

	public double GetAttributeRatio(){
		if( ComputedValues.MAXKEYSUSED != 0 )
			return((double)attributes/(double)ComputedValues.MAXKEYSUSED);
		return((double)0.0);
	}
	
	public double GetDatalengthRatio(){
		if( ComputedValues.MAXDATALEN != 0 )
			return((double)datalen/(double)ComputedValues.MAXDATALEN);
		return((double)0.0);
	}

	public int GetAttributes() {
		return attributes;
	}

	public int GetDatalen() {
		return datalen;
	}
	
}