package forepost;
import java.util.*;

public class MethodExecTimes implements MethodData 
{
	public String container = null;
	public String name = null;
	private ArrayList<Double> signals = new ArrayList<Double>();
	private ArrayList<Double> artime = new ArrayList<Double>();
	private ArrayList<Method> ProfileMethods = new ArrayList<Method>();
	// QI
	public Double minSignal = 30.0;
	
	public double getMinSignal() {
		if (signals.size() == 0){
			System.out.println("Signals list is empty! " );
		}
		for(int i = 0; i < signals.size(); i ++) {
			if (minSignal > signals.get(i)) {
				minSignal = signals.get(i);
			}
		}
		return minSignal;
	}
	
	public ArrayList<Double> getSignals() {
		return signals;
	}
	
	public MethodExecTimes( int profSize, Method m ) throws Exception
	{
		if( m == null ){
			throw new Exception("Method object cannot be null");
		}
		if( profSize <= 0 ){
			throw new Exception("Incorrect number of profiles: " + String.valueOf(profSize));
		}

		container = m.getContainer();
		name = m.getName();
		artime = new ArrayList<Double>(profSize);
		for( int i = 0; i < profSize; i++ ){
			artime.add(i, Double.valueOf(0.0));
		}
		ProfileMethods.add(m);
	}
	
	public void AddSignal(int component, double value ){
		signals.add(component, Double.valueOf(value));
	}
	
	public double GetSignal( int component ){
		return( signals.get(component).doubleValue());
	}
	
	public String getContainer(){
		return(container);
	}

	public String getName(){
		return(name);
	}
	
	public void SetTime( int index, double value ) throws Exception
	{
		if( index < 0 ){
			throw new Exception("Index value should be >= 0");
		}
		artime.set(index, Double.valueOf(value));
	}

	public boolean Compare( String cont, String mparms ) {
		if( cont == null || mparms == null )
			return(false);
			
		if( cont.compareTo(this.getContainer()) == 0 && mparms.compareTo(this.getName()) == 0 )
			return(true);
		
		return(false);
	}

	public boolean Compare( Method m ) {
		if( m == null )
			return(false);
			
		if( m.getContainer().compareTo(this.getContainer()) == 0 && m.getName().compareTo(this.getName()) == 0 )
			return(true);
		
		return(false);
	}
	
	public void AddTime( double tm ){
		artime.add(tm);
	}

	public ArrayList<Double> GetTimes(){
		return(artime);
	}

	public void AddMethod(Method m) {
		if( m != null )
			ProfileMethods.add(m);
	}
}
