package forepost;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;
import java.util.logging.Level;

public class NewArffManager extends ArffManager{
	
	private HashSet<String> multipleValueKeys = new HashSet<String>();
	protected Hashtable<String, ArrayList<String>> UniqueKeysValues = new Hashtable<String, ArrayList<String>>();
	
	public NewArffManager(String arffFileName, LinkedList <ProfileParser> table) throws Exception{
		super( arffFileName, table);
		multipleValueKeys.clear();
	}
	
	public void AddUniqueKeyValue( String key, String val ) throws Exception
	{
		if( key == null ){
			throw new Exception("Key string cannot be null");
		}

		if( val == null ){
			throw new Exception("Value string cannot be null");
		}
		
		if( val.length() == 0 || key.length() == 0 ){
			return;
		}
		
		if( key.toLowerCase().endsWith("unselected") ){
			key = key.toLowerCase();
			int ind = key.indexOf("unselected");
			key = key.substring(0, ind);
		}

		
		ArrayList<String> Vals = UniqueKeysValues.get(key);
		if( Vals == null ){
			Vals = new ArrayList<String>();
			Vals.add(val);
			UniqueKeysValues.put(key, Vals);
//			System.out.println("Adding the first value for the key " + key );
		} else {
			Iterator<String> it = Vals.iterator();
			while( it.hasNext() ){
				String kv = it.next();
				if( kv.compareTo(val) == 0 ){
					return;
				}
			}
//			System.out.println("There are " + Vals.size() + " values for the key " + key );
			Vals.add(val);
			
		}
	}

	
	public void CreateArffData(String relationName, ArffManager.KINDOFDATA kod, int numProfilesFromTable ) throws Exception {
		super.CreateArffData(relationName);
		BufferedReader in = new BufferedReader(new FileReader("C:\\Research\\workspace_AFOCMS\\JMeterScript\\input.txt"));
		String tmp = null, outstr = "";
		String helo="";
		ArrayList attrList = new ArrayList();
		while((tmp=in.readLine())!=null) {
			String[] tokens = tmp.split(",");
			outstr = outstr +  ATTRIBUTE + " " + tokens[0] +" NUMERIC\n";
			attrList.add(tokens[0]);
		}
		output.write( outstr );
		outstr = ATTRIBUTE + " class { ";
		Iterator<String> iter = Classes.iterator();
		while( iter.hasNext() ){
			outstr += iter.next();
			if( iter.hasNext() )
				outstr += ", ";
		}
		outstr += " , Unassigned }\n\n";
		output.write( outstr );
		output.write("\n@DATA\n");
		for(int i = 0; i < numProfilesFromTable; i++ ){
			ProfileParser pp = profiles.get(i);
			if( pp!= null )
			{
				outstr = "";
				HashMap profileInfo = pp.getCurrProfileInfo().getRuleCount();
				for(int j = 0; j < attrList.size(); j++) {
					if(j == attrList.size() - 1)
						outstr = outstr + profileInfo.get(attrList.get(j)) + "," +pp.getProfileClass();
					else
						outstr = outstr + profileInfo.get(attrList.get(j)) + ",";
				}
				output.write(outstr+"\n");
			}
		}
		output.close();
	}

}
