package forepost;

import java.io.*;
import java.util.*;
import java.util.logging.Level;
import forepost.utilities.*;

import org.apache.jmeter.JMeter;
import org.apache.log4j.Logger;
import org.fastica.*;

import com.accenture.techlabs.assist.profile.ProfRepository;
import java.util.logging.*;

public class ProfileAnalyzer implements Runnable, ProfileStatistics   
{
	// QI
	private static final Logger logger = Logger.getLogger(ProfRepository.class);
	
	private ProcessingStatus Status = ProcessingStatus.STOPPED;
	final String looptoken = "\\_";
	final String STARTLOOP = "START_LOOP";
	final String ENDLOOP = "END_LOOP";
	final String STARTPROFILE = "START_PROFILE";
	final String ENDPROFILE = "END_PROFILE";
	final String EXCEPTIONSTART = "EXCEPTION_START";
	final String EXCEPTIONEND = "EXCEPTION_END";
	int currentLoop = 0, currentProfileCount = 0;
	private Rules rules = null;
	int numLearning = 0;
	
	HashMap<String, double [][]> ProfileMatrices = new HashMap<String, double [][]>();
	HashMap<String, double [][]> MixinMatrices = new HashMap<String, double [][]>();
	HashMap<String, double [][]> IcaMatrices = new HashMap<String, double [][]>();
	LinkedList<ProfileTable> ProfileTables = new LinkedList<ProfileTable>();
	HashMap<String, ProfileTable> ClusteredProfileTable = new HashMap<String, ProfileTable>(); 
	private startGUI forepostGUI = null;
	
	
// QI
	LinkedList<double[][]> mixingMatrices = new LinkedList<double[][]>();
	LinkedList<double[][]> icaMatrices = new LinkedList<double[][]>();
	HashMap<String, Components> components = new HashMap<String, Components>();
	String fileName = new String("C:\\Research\\workspace_AFOCMS\\JMeterScript\\Results\\");
	HashMap<String, double [][]> separatingMatrices = new HashMap<String, double [][]>();
	LinkedList<MethodExecTimes> finalMethodExec = new LinkedList<MethodExecTimes>();
	
	public class bottlenecks {
		public ArrayList<Double> goodSignal;
		public ArrayList<Double> badSignal;
		public String methodName;
		public String methodContainer;
		public double signalsDiff;
		public double gs;
		public double bs;
		public bottlenecks (ArrayList<Double> gs, ArrayList<Double> bs, String mn, String mc, double sd) {
			this.badSignal = bs;
			this.goodSignal = gs;
			this.methodContainer = mc;
			this.methodName = mn;
			this.signalsDiff = sd;
			this.gs = 0.0;
			this.bs = 0.0;
		}
	}
	LinkedList<bottlenecks> listOfBottlenecks = new LinkedList<bottlenecks> ();
	ArrayList<bottlenecks> finalList = new ArrayList<bottlenecks>();
// QI	
	
    public static int numOfRules = 0;
    public static int numP = 0;
	private nonGUI forepostNonGUI = null;
	
	
	private double [][] Matrix = null;
	private ProfileParser currentProfile = null;
	LinkedList <ProfileParser> profiles = new LinkedList <ProfileParser>();
	private ArrayList <RuleCountClass> SingleProfileData = new ArrayList<RuleCountClass>();
	private DataArffManager arffInputParams = null;
	private NewArffManager arffinput = null, arffDbData = null;
	private boolean suspend = false, shutdown = false;
	String event = null;
	long row = 0;
	private String repositoryPath = null;
	LinkedList<String> Classes = new LinkedList<String>();
	DecisionTreeVisualizer treeViz = null;

	public void startGUI() throws Exception
	{
		try {
			forepostGUI = new startGUI(this);
		     new Thread(forepostGUI).start();
		     System.out.print("Started the GUI\n");
		} catch (Exception e) {
			FPUtility.getLogger().info("Exception launching the GUI");
			e.printStackTrace();
		}
		
//		try {
//			forepostNonGUI = new nonGUI(this);
//		     new Thread(forepostNonGUI).start();
//		     System.out.print("Started the nonGUI\n");
//		} catch (Exception e) {
//			FPUtility.getLogger().info("Exception launching the GUI");
//			e.printStackTrace();
//		}
	}
	
	
	public ProfileAnalyzer(String repositoryPath) throws Exception
	{
		FPUtility.startRuleInfoLogging(true);
		this.repositoryPath = repositoryPath;
		if( this.repositoryPath == null )
			throw new Exception("Repository path is null");
		//Code modified by Aswathy Nair
		//generate ARFF file
		//
		//arffInputParams = new DataArffManager(FPUtility.getARFFInputParamsFile(),profiles);
		//arffDbData = new DataArffManager(FPUtility.getARFFDbDataFile(),profiles);
		arffinput = new NewArffManager(FPUtility.getARFFInputParamsFile(),profiles);
		ClusteredProfileTable.clear();
	}

	public void Shutdown(){
		System.out.println("Shutting down after processing ");
		shutdown = true;
	}
	
	public void Suspend(){
		arffInputParams.CreateScreenInputDataXml();
		suspend = true;
	}

	public void Resume(){
	    if(suspend==true) {
	        suspend = false;
			synchronized(this) {
	        notifyAll();
			}
	    }	
	   }
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	//@Override
	public void run() {
		try {
//			logger.info("start to analyze the profiles"); //QI
			//ProfRepository.mockStart(repositoryPath);
//			FPUtility.getLogger().info("Starts reading data from the repository at " + repositoryPath); 
			do{
				synchronized(this) {
					if( suspend ) setStatus(ProcessingStatus.PAUSED);
					while(suspend) wait();
				}
				
				setStatus(ProcessingStatus.PROCESSING);
				event = ProfRepository.getProfileLine();// May block
				if (event == null){
					FPUtility.getLogger().log(Level.FINER, "Data string is retrieved from the repository as null");
					Thread.sleep(5000);
				}
//				System.out.println(event);
				if( ++row % 100000 == 0 ){
//					FPUtility.getLogger().log(Level.ALL, "Processing row ", row);
					System.out.println("Processing row " + String.valueOf(row) + " for loop " + String.valueOf(currentLoop) );
				}
				if( !Parse() ){
//					FPUtility.getLogger().log(Level.SEVERE, "Parsing failure for entry ", event );
				}
				
			}while( !shutdown );
			
//			FPUtility.getLogger().log(Level.ALL, "Shutting down after processing ", String.valueOf(row) + " rows");
//			System.out.println("Shutting down after processing " + String.valueOf(row) + " rows");

		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
//		this.startGUI();
		
	}
	
	private boolean Parse()
	{
		//logger.info("parse the profiles to display!"); //QI
		int temp = 0;
		try {
			/*if( (temp=IsStartingLoop()) > 0 ){
				currentLoop = temp;
//				FPUtility.getLogger().log(Level.ALL, "Starting loop ", currentLoop );
//				System.out.println("Starting loop " + currentLoop );
				currentProfile = null;
			}
			else if( IsEndingLoop() ){
//				System.out.println("Ending loop " + currentLoop );
				if(currentLoop == 1){
					arffInputParams.CreateScreenInputDataXml();
					arffInputParams.CreateACTSInputData();
					arffInputParams.CreateCSVInputData();
				}
				FPUtility.getLogger().log(Level.ALL, "Ending loop ", currentLoop );
				currentProfile = null;
			}*/
			if( IsStartingProfile() ){
//				FPUtility.getLogger().log(Level.ALL, "Starting profile ", currentProfile );
				System.out.println("Starting profile " + currentProfileCount );
				currentProfile = new ProfileParser();
				currentProfile.setLoop(currentLoop);
				//Code modified by Aswathy Nair
				//Generate ARFF Input
				//
				//currentProfile.SetInputParamARFFMgr(arffInputParams);
				currentProfile.SetInputParamARFFMgr(arffinput);
				currentProfile.SetDataARFFMgr(arffDbData);
			}
			else if( IsEndingProfile() ){
				//Code modified by Aswathy Nair
				//to generate ARFF Input
				//
				RuleCountClass ProfileInfo = new RuleCountClass();
				ProfileInfo.setRuleCount(RequestParser.ruleCountMap);
				ProfileInfo.setRuleClass(null);
				if(ProfileInfo != null && ProfileInfo.getRuleCount() != null)
					currentProfile.setCurrProfileInfo(ProfileInfo);
				synchronized (this){
					profiles.add(currentProfile);
				}
				numP ++;
//				System.out.println("Ending profile " + currentProfileCount );
//				arffInputParams.CreateACTSInputData();
				double elapsedTime = currentProfile.GetElapsedTime();
				int numMethods = currentProfile.GetMethods();
				int invocations = currentProfile.GetInvocations();
				int attr = currentProfile.GetAttributes();
				int data = currentProfile.GetDatalen();
				forepostGUI.SetProfileInfo(currentProfileCount, elapsedTime, numMethods, invocations, attr, data);
//				FPUtility.getLogger().log(Level.ALL, "Ending profile "+currentProfileCount +
//						" Time:" + elapsedTime + " Methods: "+numMethods+
//						" Invocations: "+invocations +" Attributes: "+attr+" Data: "+data +
//						" Analyzer Memory Consumption: "+(Runtime.getRuntime().totalMemory()- Runtime.getRuntime().freeMemory()));
			 
				currentProfile = null;
				Iterator iter = RequestParser.ruleCountMap.entrySet().iterator(); 
				while (iter.hasNext()) { 
				    Map.Entry entry = (Map.Entry) iter.next(); 
//				    Object key = entry.getKey(); 
//				    Object val = entry.getValue(); 
				    entry.setValue(0);
				} 
//				arffInputParams.CreateCSVInputData();
			}
			else if( currentProfile != null ) {
				if( !currentProfile.Parse(event) ){
//					FPUtility.getLogger().log(Level.SEVERE, "Failed to parse an entry in the profile ", currentProfileCount );
					return( false );
				}
			}
			else {
//				FPUtility.getLogger().log(Level.SEVERE, "An unrecognizable entry is found in profile ", currentProfileCount );
				//we simply discard anything in the execution trace file that falls between the loop and profile markers or other combinations of markers
//				if( currentLoop > 0 )
//					System.out.println("Entry: " + event );
				return( true );			
			}
		} catch (Exception e) {
			try {
//				FPUtility.getLogger().log(Level.SEVERE, "An exception occured in profile ", currentProfileCount );
			} catch (Exception e1) {
				e1.printStackTrace();
			}
			e.printStackTrace();
			return( false );
		}
		return( true );
	}
	
	private int IsStartingLoop() throws Exception
	{
		if( event != null && event.startsWith(STARTLOOP) == true ) {
			String [] entries = event.split(looptoken);
			if( entries == null )
				throw new Exception( "No loop number in the token" );
			setStatus(ProcessingStatus.PROCESSING);
			return( Integer.parseInt(entries[2]) );
		}
		return( 0 );
	}

	private boolean IsEndingLoop() throws Exception
	{
		if( event != null && event.startsWith(ENDLOOP) == true ) {
			setStatus(ProcessingStatus.TRANSITIONING);
			forepostGUI.statsDisplay();
			return( true );
		}
		return( false );
	}

	private boolean IsStartingProfile() throws Exception
	{
		if( event != null && event.startsWith(STARTPROFILE) == true ) {
			setStatus(ProcessingStatus.PROCESSING);
			++currentProfileCount;
//			FPUtility.getLogger().info("Start processing profile #" + String.valueOf(currentProfileCount)); hide_focus
			return( true );
		}
		return( false );
	}

	private boolean IsEndingProfile() throws Exception
	{
		if( event != null && event.startsWith(ENDPROFILE) == true ) {
//			FPUtility.getLogger().info("Finished processing profile #" + String.valueOf(currentProfileCount));
			setStatus(ProcessingStatus.TRANSITIONING);
			if( currentProfile != null ){
				try {
//					logger.info("display the profiles"); //QI
					currentProfile.MaxTime();
					forepostGUI.statsDisplay();
					
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return( true );
		}
		return( false );
	}

	private boolean IsStartingException()
	{
		if( event != null && event.startsWith(EXCEPTIONSTART) == true ) {
			setStatus(ProcessingStatus.PROCESSING);
			return( true );
		}
		return( false );
	}

	private boolean IsEndingException()
	{
		if( event != null && event.startsWith(EXCEPTIONEND) == true ) {
			setStatus(ProcessingStatus.PROCESSING);
			return( true );
		}
		return( false );
	}
	
	
	public int GetTotalProfiles(){
		return( profiles.size() );
	}

	synchronized public void Analyze(boolean autoCluster, int numProfilesFromTable, boolean overwriteARFF )
	{
		try {
			if( autoCluster ){
			
				System.out.println("Running analyses: autoclustering...");
				CreateArff4Clustering(numProfilesFromTable);
//				System.out.println("Running analyses: created ARFF for clustering...");
				//random assign
//				ClusterProfiles();
				forepostGUI.setClassList();
				
				System.out.println("Running analyses: profiles have been clustered.");
			}
			BreakProfilesByClasses(numProfilesFromTable);
			CreateArff4Classification(numProfilesFromTable, overwriteARFF);
			System.out.println("Running analyses: created ARFF for classification. Starting rule extraction...");
			rules = ComputeRules();
			if( rules == null ){
				System.out.println("No rules have been computed.");
				return;
			}
			Iterator<Rule> ruleIt = rules.iterator();
			JMeter.rules = new Rules();
//			logger.info("add the rules into JMeter!"); //QI
			while(ruleIt.hasNext()){
				Rule rl = ruleIt.next();
				forepostGUI.SetRuleInfo(true, rl.getRuleText(), rl.GetRuleClass());
				//Code modified by Aswathy Nair
				//
				//
				JMeter.rules.AddRule(rl);
			}

//			ExtractRules();
//			System.out.println("Finished analyses successfully.");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

    // QI
	public void analyzeICA() {
		try {

			int icaComponents = 5;
			numLearning ++;

			System.out.println("Constructing profile matrices");
			long start = System.currentTimeMillis();

			ProfileMatrices.clear();

			ConstructProfileMatrix();

			System.out.println("Writing info about methods in a file");

			System.out.println("Running ICA");
			RunICA(icaComponents);
			System.out.println("profiles.size: " + profiles.size());

			String pClass = null;
			Collection<String> keys = ProfileMatrices.keySet();
			Iterator<String> itKeys = keys.iterator();
			while (itKeys.hasNext()) {

				pClass = itKeys.next();
				double [][] mm = getMixingMatrix(pClass);
				double [][] icm = getICAMatrix(pClass);
				double [][] sm = getSeparatingMatrix(pClass);
				System.out.println("Outputting signal components");


				Components compI = new Components(ClusteredProfileTable.get(pClass).GetListOfMethods(), icm);
				components.put(pClass, compI);
				String fileNameStr = fileName + pClass.toString() + "Matix_" + numLearning + ".txt";
				Writer output = null;
				File file = new File(fileNameStr);
				output = new BufferedWriter(new FileWriter(file));
				String outStr;
				for( int i = 0; i < icm.length; i++ ){
					for(int j = 0; j < icm[i].length; j++){
						outStr = String.valueOf(icm[i][j]) + "	";
						output.write(outStr);
					}	
					output.write("\n");
				}
				output.write("icm size: " + icm[0].length);
				output.write("number of components: " + icaComponents);
				output.flush();
			    output.close();
				//compI.PrintAll(fileNameStr);
			}
			
			computeBottlenecks(components);
			
			for (int i = 0; i < 30; i ++){
				forepostGUI.SetBottleneckInfo(finalList.get(i).methodContainer, finalList.get(i).methodName,
						finalList.get(i).signalsDiff);
			}
	
			long end = System.currentTimeMillis();
			System.out.println("Finished analyzing " + profiles.size() + " profiles in " + String.valueOf((double)(end-start) / (double)1000.0) + " sec.");
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	private void computeBottlenecks (HashMap<String, Components> components) throws Exception {
		if (components == null) {
			FPUtility.getLogger().log(Level.SEVERE, "Components is null!");
			return;
		}
		
		if (components.size() > 2) {
			FPUtility.getLogger().log(Level.SEVERE, "There are profiles unassigned!");
			return;
		}

		Set s = components.entrySet();
        Iterator it = s.iterator();
        Components compGood = null;
        Components compBad = null;

        while(it.hasNext()) {
        	
        	Map.Entry m =(Map.Entry)it.next();
        	String key=(String)m.getKey();
        	if (key == "Good") {
        		compGood = (Components)m.getValue();
        		
        	} else {
        		compBad = (Components)m.getValue();
        	}
        }
        
        //String fileNameStrGood = fileName + "maxGoodWeights_" + numLearning + ".txt";
		//Writer output = null;
		//File file = new File(fileNameStrGood);
		//output = new BufferedWriter(new FileWriter(file));
		//String outStr;
        
		boolean isEnd = false;
		System.out.println(compGood + "\n");
		System.out.println(compBad+"\n");
        Enumeration <Integer> eGoodCal = compGood.signals.keys();

        listOfBottlenecks.clear();
        while(eGoodCal.hasMoreElements() && !isEnd ) {
        	Integer signalGoodCal = eGoodCal.nextElement();
			LinkedList<MethodExecTimes> methodExecGoodCal = compGood.signals.get(signalGoodCal);

			System.out.println("list size:" + methodExecGoodCal.size());
        	for (int i = 0; i < methodExecGoodCal.size(); i ++) {
        		MethodExecTimes met = methodExecGoodCal.get(i);
        		ArrayList<Double> gs = met.getSignals();
        		ArrayList<Double> bs = new ArrayList<Double>();
        		String mn = met.getName();
        		String mc = met.getContainer();
        		bottlenecks bn = new bottlenecks(gs, bs, mn, mc, 0.0);
        		listOfBottlenecks.add(bn);
        		//outStr = "method name: " + met.getName() + "\n" + " method container: " + met.getContainer() + "\n" +
        		//"method max signal: " + met.getMaxSignal() + "\n";
        		//outStr = "method name: " + met.getName() + "\n" + " method container: " + met.getContainer() + "\n" + "Good signal: "
        		//+ met.GetSignal(signalGoodCal.intValue()) + "\n" + "method max signal: " + met.getMaxSignal() + "\n";
				//output.write(outStr);
        	}
        	//output.write("number of methods:" + methodExecGoodCal.size());
        	isEnd = true;
        }
		//output.flush();
	    //output.close();
	    //output = null;
        
        isEnd = false;
        
        Enumeration <Integer> eBadCal = compBad.signals.keys();
        while(eBadCal.hasMoreElements() && !isEnd) {
        	Integer signalBadCal = eBadCal.nextElement();
			LinkedList<MethodExecTimes> methodExecBadCal = compBad.signals.get(signalBadCal);
			
			for (int i = 0; i < methodExecBadCal.size(); i ++) {
        			MethodExecTimes met = methodExecBadCal.get(i);
        			for (int j = 0; j < listOfBottlenecks.size(); j ++) {
        				if ( (met.getName().equals(listOfBottlenecks.get(j).methodName)) && 
        						(met.getContainer().equals(listOfBottlenecks.get(j).methodContainer)) ) {
        					listOfBottlenecks.get(j).badSignal = met.getSignals();
        				}
        			}
        		}
        }

        
        for (int i = 0; i < listOfBottlenecks.size(); i ++) {
        	ArrayList<Double> gs = listOfBottlenecks.get(i).goodSignal;
        	ArrayList<Double> bs = listOfBottlenecks.get(i).badSignal;
        	ArrayList<Double> expSignal = new ArrayList<Double>();
        	ArrayList<Double> orgSignal = new ArrayList<Double>();
        	
        	int size = 0;
        	int interval = 0;
        	if (gs.size() <= bs.size()) {
        		size = bs.size();
        		interval = bs.size() - gs.size();
        		expSignal = gs;
        		orgSignal = bs;
        	} else {
        		size = gs.size();
        		interval = gs.size() - bs.size();
        		expSignal = bs;
        		orgSignal = gs;
        	}
        	
        	if (interval != 0){
        		for (int j = 0; j < interval; j ++){
        			expSignal.add(0.0);
        		}
        	}
        	/*double maxGs = 0.0;
        	double maxBs = 0.0;
        	for (int j = 0; j < gs.size(); j ++ ) {
        		if (gs.get(j) > maxGs) {
        			maxGs = gs.get(j);
        		}
        	}
        	for (int j = 0; j < bs.size(); j ++ ) {
        		if (bs.get(j) > maxBs) {
        			maxBs = bs.get(j);
        		}
        	}
        	listOfBottlenecks.get(i).gs = maxGs;
        	listOfBottlenecks.get(i).bs = maxBs;
        	listOfBottlenecks.get(i).signalsDiff = maxGs - maxBs;*/
        	Double diff = 0.0;
        	Double di = 0.0;
        	for (int j = 0; j < size; j ++) {
        		double d = (orgSignal.get(j)-expSignal.get(j)) * (orgSignal.get(j)-expSignal.get(j));
        		diff = diff + d;Math.sqrt(d);
        	}
        	di = Math.sqrt(diff);
        	listOfBottlenecks.get(i).signalsDiff = di;
        }
        
        int n = listOfBottlenecks.size();
        double[] midDiffs = new double[n];
        double[] valueDiffs = new double[n];
        int[] indexDiffs = new int[n];
        for (int i = 0; i < n; i ++) {
        	midDiffs[i] = 0.0;
        	valueDiffs[i] = 0.0;
        	indexDiffs[i] = 0;
        }
        
        for (int i = 0; i < listOfBottlenecks.size(); i ++){
        	midDiffs[i] = listOfBottlenecks.get(i).signalsDiff;
        	valueDiffs[i] = listOfBottlenecks.get(i).signalsDiff;
        	//System.out.println("midDiffs[" + i + "] = " + midDiffs[i]);
        }
        
        System.out.println("n: " + n);
        Arrays.sort(midDiffs);
        double[] diffs = new double[n];
        for (int i = 0; i < n; i ++) {
        	diffs[i] = midDiffs[n-1-i];
        	int value = n-1-i;
        	//System.out.println("Diffs[" + value + "] = " + diffs[n-1-i]);
        }
        
        for (int i = 0; i < n; i ++) {
        	double value = diffs[i];
        	for (int j = 0; j < n; j ++) {
        		if ( value == valueDiffs[j]){
//        			System.out.println("find the new position for: " + i);
        			indexDiffs[i] = j;
        			valueDiffs[j] = -1000;
        			j = n;
        		}
        	}   
        }
        
        String fileNameStrBottlenecks = fileName + "bottlenecks_" + numLearning + ".txt";
		File fileBottlenecks = new File(fileNameStrBottlenecks);
		Writer output = null;
		output = new BufferedWriter(new FileWriter(fileBottlenecks));
		String outStr = "";
        
		finalList.clear();
		for (int i = 0; i < n; i ++) {
			bottlenecks bn = listOfBottlenecks.get(indexDiffs[i]);
			finalList.add(bn);
			outStr = "No." + i + "  bottleneck, with the order in the list is: " + indexDiffs[i] + "\n" + "method name: " + bn.methodName + "\n" + "method container: " + bn.methodContainer + "\n" + 
    		"signals difference: " + bn.signalsDiff + "\n" + "good signal: " + bn.goodSignal + "\n" + "bad signal: " 
    		+ bn.badSignal + "\n" + "\n"; 				
			output.write(outStr);
			//System.out.println(i);
			/*for ( int j = 0; j < listOfBottlenecks.size(); j ++) {
				
				if ( value == bn.signalsDiff) {
					System.out.println("i: " + i);
					finalList.add(bn);
					outStr = "No." + i + "  bottleneck, with the order in the list is: " + j + "\n" + "method name: " + bn.methodName + "\n" + " method container: " + bn.methodContainer + "\n" + 
	        		"signals difference: " + bn.signalsDiff + "\n" + "good signal: " + bn.goodSignal + "\n" + "bad signal: " 
	        		+ bn.badSignal + "\n" + "\n"; 				
					output.write(outStr);
					listOfBottlenecks.remove(j);
				}
			}*/
		}
		output.flush();
	    output.close();
	}
	
	
// QI 
/*	
	synchronized public void AnalyzeOld(boolean autoCluster, int icaComponents)
	{
		try {
			if( autoCluster ){
			
				System.out.println("Running analyses: autoclustering...");
				CreateArff4Clustering();
				System.out.println("Running analyses: created ARFF for clustering...");
				//random assign
//				ClusterProfiles();
				forepostGUI.setClassList();
				
				System.out.println("Running analyses: profiles have been clustered.");
			}
			BreakProfilesByClasses();
			CreateArff4Classification();
			System.out.println("Running analyses: created ARFF for classification. Starting rule extraction...");
//			ExtractRules();
//			System.out.println("Running analyses: rules have been extracted. Constructing profile matrices for ICA...");
//			ConstructProfileMatrix();
//			System.out.println("Running ICA...");
//			RunICA(icaComponents);
					System.out.println("Finished analyses successfully.");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
*/
	
	private boolean RunICA( int icaComponents ) throws Exception 
	{
		String pClass = null;
		Collection<String> keys = ProfileMatrices.keySet();
		Iterator<String> itKeys = keys.iterator();
		while (itKeys.hasNext())
		{
			pClass = itKeys.next();
			Matrix = ProfileMatrices.get(pClass);
//			System.out.println("Running ICA on profiles of the class " + pClass );
			FastICA ica;
			try {
				ica = new FastICA( Matrix, icaComponents );
			} catch (Exception e) {
				e.printStackTrace();
				return(false);
			}
			MixinMatrices.put(pClass, ica.getMixingMatrix());
			IcaMatrices.put(pClass, ica.getICVectors());
			separatingMatrices.put(pClass, ica.getSeparatingMatrix()); // QI
		}
		return(true);
	}
		
	public double [][] getMixingMatrix(String pClass) throws Exception
	{
		if(pClass == null)throw new Exception("No mixin matrix for the class null");
		return(MixinMatrices.get(pClass));
	}

//QI
	
	public double [][] getSeparatingMatrix(String pClass) throws Exception {
		if(pClass == null)throw new Exception("No mixin matrix for the class null");
		return(separatingMatrices.get(pClass));
	}
	
//QI
	public double [][] getICAMatrix(String pClass) throws Exception
	{
		if(pClass == null)throw new Exception("No ICA matrix for the class null");
		return(IcaMatrices.get(pClass));
	}

	public void ConstructProfileMatrix() throws Exception {
		Set s = ClusteredProfileTable.entrySet();
        Iterator it = s.iterator();

        while(it.hasNext())
        {
        	Map.Entry m =(Map.Entry)it.next();
        	String key=(String)m.getKey();
        	ProfileTable value=(ProfileTable)m.getValue();
        	if( key != null && value != null ){
        		value.ProcessProfiles();
        		Matrix = value.getMatrix();
        		if( Matrix != null ){
        			if(!ProfileMatrices.containsKey(key)){
        				ProfileMatrices.put(key, Matrix);
        			}
        		}
        	}
        }		
	}

	private void BreakProfilesByClasses( int numProfilesFromTable ) throws Exception
	{
//		logger.info("break the profiles by classes!"); //QI
		int profSeqNum = 0;
		ClusteredProfileTable.clear();
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileTable pt = null;
		ProfileParser p = null;
		String className = null;
		while( iter.hasNext() )
		{
			if( profSeqNum++ >= numProfilesFromTable )
				break;
			p = iter.next();
			if( p != null ){
				className = p.getProfileClass();
				if( className == null ){
					FPUtility.getLogger().log(Level.SEVERE, "Profile class is null for profile " + String.valueOf(iter.nextIndex()-1));
					continue;
				} else if(className.compareTo(FPUtility.UNASSIGNEDCLASS)==0){
					FPUtility.getLogger().log(Level.SEVERE, "Profile class is not assigned for profile " + String.valueOf(iter.nextIndex()-1));
					continue;					
				}
				if( !ClusteredProfileTable.containsKey(className) ){
					pt = new ProfileTable(className);
				}
				else {
					pt = ClusteredProfileTable.get(className);
				}
				pt.AddProfile(p);
				ClusteredProfileTable.put(className, pt);
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
	}
	
	
	private void CreateArff4Clustering(int numProfilesFromTable) {
		try {
//			logger.info("create an arff file for cluster!"); //QI
			ProfileArffManager cluster = new ProfileArffManager(FPUtility.getARFFClusterProfileFile(), profiles );
			cluster.CreateArffData("ProfileStatistics");
//			BI = cluster.SpecifyIBProfiles();
//			ClusterProfiles cp = new ClusterProfiles( destDirectory+"ClusterProfiles.arff" );
		} catch (Exception e) {
			e.printStackTrace();
		} 		
	}
	
	public void ClusterProfiles() throws Exception {
		Classes.clear();
		Classes.add("Bad");
		Classes.add("Good");
		Classes.add("NotSure");
		Random randomGenerator = new Random();
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				
				p.SetProfileClass(Classes.get(randomGenerator.nextInt(3)));
				
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}		
	}

	private void CreateArff4Classification(int numProfilesFromTable, boolean overwriteARFF) {
//		logger.info("create an arff file for classification!"); //QI
		try {
			if( overwriteARFF ){
				//arffInputParams.setClasses(getClasses());
				//arffDbData.setClasses(getClasses());
				//arffDbData.CreateArffData("IMSValues", ArffManager.KINDOFDATA.IMS, numProfilesFromTable);
				//arffInputParams.CreateArffData("InputParameters",ArffManager.KINDOFDATA.INPUTPARAMS, numProfilesFromTable);
				arffinput.setClasses(getClasses());
				arffinput.CreateArffData("InputParameters",ArffManager.KINDOFDATA.INPUTPARAMS,numProfilesFromTable);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} 		
	}
	
	public Rules ComputeRules() throws Exception {
		ForePostRuleClassifier ruleClass = new ForePostRuleClassifier(FPUtility.getARFFInputParamsFile()); 
		if( ruleClass.Classify() ) {
			rules = ruleClass.ProcessRules(); 
			return(rules);
		}
		return( rules = null );
	}

	public void GetInputParamDecisionTree() throws Exception
	{
		try {
			ComputeDecisionTree( FPUtility.getARFFInputParamsFile() );
		} catch (Exception e) {
			FPUtility.getLogger().log(Level.SEVERE, "Failed to compute a decision tree");
			e.printStackTrace();
		}
	}
	
	private void ComputeDecisionTree( String arffFile ) throws Exception 
	{
		DecisionTreeVisualizer treeViz = new DecisionTreeVisualizer(arffFile);
		treeViz.Classify();
		treeViz.Visualize();
	}
	
	
	public int GetMethods() throws Exception{
		int total = 0;
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				total += p.GetMethods();
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
		return( total );
	}
	
	public int GetInvocations() throws Exception{
		int total = 0;
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				total += p.GetInvocations();
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
		return( total );
	}
	
	public double GetElapsedTime() throws Exception{
		double total = 0.0;
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				total += p.GetElapsedTime();
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
		return( total );
		
	}
	
	public int GetThreads() throws Exception{
		int total = 0;
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				total += p.GetThreads();
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
		return( total );
		
	}
	
	public int GetAttributes() throws Exception{
		int total = 0;
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				total += p.GetAttributes();
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
		return( total );
		
	}
	
	public int GetDatalen() throws Exception{
		int total = 0;
		ListIterator<ProfileParser> iter = profiles.listIterator();
		ProfileParser p = null;
		while( iter.hasNext() )
		{
			p = iter.next();
			if( p != null ){
				total += p.GetDatalen();
			}
			else{
				throw new Exception( "Profile object is null" );			
			}
		}
		return( total );
		
	}

	public void setStatus(ProcessingStatus status) {
		Status = status;
	}

	public ProcessingStatus getStatus() {
		return Status;
	}

	public void SetProfileClass( String Class, int profileID ) throws Exception
	{
		FPUtility.getLogger().log(Level.FINEST, "Setting profile " + String.valueOf(profileID) + " to class " + Class );
		if( Class == null || profileID >= profiles.size() ) throw new Exception("Wrong parameters to set a profile class");
		
		profiles.get(profileID).setProfileClass(Class);
	}

	public LinkedList<String> getClasses() {
		return Classes;
	}

	public void setClasses(LinkedList<String> classes) throws Exception {
		if( classes == null )throw new Exception("The list of classes cannot be null");
		Classes = classes;
	}
	
	@SuppressWarnings("unused")
	private void PrintAll() throws Exception {
		try 
		{
			Writer output = null;
			output = new BufferedWriter(new FileWriter(FPUtility.getFullProfileDataFile()));
	
			ListIterator<ProfileParser> iter = profiles.listIterator();
			ProfileParser p = null;
			while( iter.hasNext() )
			{
				p = iter.next();
				if( p != null ){
					System.out.println( "Profile " + String.valueOf(iter.nextIndex()-1) + ": " + String.valueOf(p.GetElapsedTimeRatio()) + " has " + String.valueOf(p.GetMethods()) + " methods, " + String.valueOf(p.GetInvocations()) + " invocations, and " + String.valueOf(p.GetThreads()) + " threads" );   
					if( p != null){
						p.PrintAll(output);
					}
				}
			}
			output.flush();
		    output.close();
			
		} catch( Exception e ){
			e.printStackTrace();
			throw new Exception( "exception when dumping profile info into a file" );
		}
		
	}

	//
	//code added by Aswathy Nair
	//for autoclustering
	//
	public String AssignClasses(double averageTime, int index) {
		//  Auto-generated method stub
			ProfileParser currprofile = profiles.get(index);
			try {
				if (currprofile.GetElapsedTime() > averageTime) {
					currprofile.setProfileClass(Classes.get(0));
					return Classes.get(0); 
				}
				else {
					currprofile.setProfileClass(Classes.get(1));
					return Classes.get(1);
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
	}
	
	/**
	public static void main(String[] args) {
		try {
			BufferedReader is = null;
			String sourceDir = "Z:\\SourceLog";
			String destDir = "Z:\\DestLog";
//			String destDir = "Z:\\TestDest";
			String resultDir = "C:\\Codebase\\DATE\\SF\\Results";

//			System.out.println("Start splitting profiles");

//			ProfilePreprocessor prep = new ProfilePreprocessor( sourceDir, destDir ); 
//			prep.ProcessProfiles();
//			System.out.println("Finished splitting profiles");

			
			System.out.println("Start processing profiles");
			long start = System.currentTimeMillis();

			ProfileAnalyzer pa = new ProfileAnalyzer( destDir, resultDir );
			pa.Analyze();
			long elapsed1 = System.currentTimeMillis()-start;
			System.out.println("Finished processing profiles in " + String.valueOf((double)(elapsed1)/(double)1000.0) + " sec");

			String profileNumber = null;
			
			while(true)
			{
				System.out.println("Total of " + String.valueOf(pa.GetTotalProfiles()) + " profiles have been processed");
				System.out.println("Please enter the desired number of top profiles to analyze: ");
				is = new BufferedReader( new InputStreamReader(System.in) );
				profileNumber = is.readLine();
				if( profileNumber.compareTo("quit")==0 ) break;
				try {
					int pn = Integer.parseInt(profileNumber);
					pa.SetNumberOfProfiles2Analyze(pn);
				} catch ( NumberFormatException e) {
					System.out.println("Not a valid integer input, please reenter.");
					continue;
				}

				pa.CreateArff4Clustering();
				
				pa.CreateArff4Classification();
				
				System.out.println("Please enter the desired number of components: ");
				is = new BufferedReader( new InputStreamReader(System.in) );
				String inv = is.readLine();
				int icaComponents = Integer.parseInt(inv);
				
				System.out.println("Constructing profile matrices");
				start = System.currentTimeMillis();
				pa.ConstructProfileMatrix();
				System.out.println("Writing info about methods in a file");
				pa.PrintAll("MethodCalls.log");
				
				System.out.println("Running ICA");
				pa.RunICA(icaComponents);
				double [][] mmI = pa.getMixingMatrix(true);
				double [][] mmB = pa.getMixingMatrix(false);
				double [][] icmI = pa.getICMatrix(true);
				double [][] icmB = pa.getICMatrix(false);
				
				System.out.println("Outputting signal components");
				Components compI = new Components(pa.GetProfileTable(true).GetListOfMethods(), icmI);
				Components compB = new Components(pa.GetProfileTable(false).GetListOfMethods(), icmB);
				compI.PrintAll(pa.GetFileName4Signals(true));
				compB.PrintAll(pa.GetFileName4Signals(false));
				compI.CrossRef(compB, 1E-3, pa.GetFileName4SignalCrossref());
				
				long end = System.currentTimeMillis();
				System.out.println("Finished analyzing " + profileNumber + " profiles in " + String.valueOf((double)(end-start)/(double)1000.0) + " sec");
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
*/
}
