package forepost;
import java.util.*;
import java.util.logging.Level;


public class ProfileArffManager extends ArffManager
{
	private final String ELAPSEDTIME = "ElapsedTime";
	private final String METHODS = "Methods";
	private final String INVOCATIONS = "Invocations";
	private final String THREADS = "Threads";
	private final String KEYS = "Keys";
	private final String DATALEN = "DataLength";
	
	public ProfileArffManager( String arffFileName, LinkedList <ProfileParser> table ) throws Exception
	{
		super(arffFileName, table);
		if( table == null ){
			throw new Exception("Profile table is null");
		}
	}

	public void CreateArffData(String relationName) throws Exception 
	{
		try 
		{
			super.CreateArffData(relationName);
			
			String outStr = "@attribute " + ELAPSEDTIME + " numeric\n";
			output.write( outStr );
			outStr = "@attribute " + METHODS + " numeric\n";
			output.write( outStr );
			outStr = "@attribute " + INVOCATIONS + " numeric\n";
			output.write( outStr );
			outStr = "@attribute " + THREADS + " numeric\n";
			output.write( outStr );
//			outStr = "@attribute " + KEYS + " numeric\n";
//			output.write( outStr );
//			outStr = "@attribute " + DATALEN + " numeric\n";
//			output.write( outStr );
			outStr = "@data\n";
			output.write( outStr );

			ListIterator<ProfileParser> iter = profiles.listIterator();
			ProfileParser pp = null;
			while( iter.hasNext() )
			{
				pp = iter.next();
				if( pp != null ){
					ProfileStatistics ppstat = (ProfileStatistics)pp;
					outStr = String.valueOf(ppstat.GetElapsedTime()) + ", " + String.valueOf(ppstat.GetMethods())  + ", " + String.valueOf(ppstat.GetInvocations()) + ", " 
						+ String.valueOf(ppstat.GetThreads())+ "\n";
						//+ ", " + String.valueOf(ppstat.GetAttributes()) + ", " + String.valueOf(ppstat.GetDatalen()) + "\n";
//					outStr = String.valueOf(ppstat.GetElapsedTime()) + ", " + String.valueOf(ppstat.GetMethods())  + ", " + String.valueOf(ppstat.GetInvocations())+ "\n";
					output.write( outStr );
				}
			}
			output.flush();
			output.close();
			System.out.println("Profile statistics arff is produced");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void SetProfileClass( int profileID, String pclass ) throws Exception
	{
		int psz = profiles.size();
		if( psz == 0 ){
			FPUtility.getLogger().log(Level.SEVERE, "Trying to set a profile class with no profiles in the system");
			throw new Exception("Trying to set a profile class with no profiles in the system");
		}
		
		if( profileID >= psz ){
			FPUtility.getLogger().log(Level.SEVERE, "Trying to set a profile class with no profiles in the system");
			throw new Exception("Trying to set a profile class with no profiles in the system");
		}
		
		try {
			profiles.get(profileID).SetProfileClass(pclass);
		} catch (Exception e) {
			throw new Exception(e);
//			e.printStackTrace();
		}
	}
}
