package forepost;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.*;

public class RequestParser extends KVDataParser
{
	private final static String token = "}";
	private final static String tokenKeyValue = "\\=\\{";
	private final static String tokenValuePlus = "\\+";
	private String currentPage = null;
	private final static String currentPageName = "currentPage";
	protected Hashtable<String, String> LocalTable = new Hashtable<String, String>();
	
	private static HashMap ruleURLMap = new HashMap();
	public static HashMap ruleCountMap = new HashMap();

	static {
		try {
		BufferedReader in = new BufferedReader(new FileReader("C:\\Research\\workspace_AFOCMS\\JMeterScript\\input.txt"));
		String str=null;
		while((str=in.readLine())!=null) {
			String[] tokens = str.split(",");
			ruleURLMap.put(tokens[1].trim(), tokens[0].trim());
			ruleCountMap.put(tokens[0].trim(), 0);
		}
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void Parse(String reqData) throws Exception{
		if( reqData == null ){
			throw new Exception("Request string cannot be null");
		}

		if( reqData.trim() == "" ){
			return ;
		}
		 //add url -- QI
		String[] url = reqData.split("\\?");
		if (url.length < 2 ) {
			
			
			
			String rulename = (String)ruleURLMap.get(url[0].trim());
			if(rulename != null) {
			if(ruleCountMap.containsKey(rulename)) {
				int temp = (Integer)ruleCountMap.get(rulename);
				ruleCountMap.put(rulename, temp+1);
			}
			else
				ruleCountMap.put(rulename, 1);
			}
		}
		
		else {
			String [] entries = url[1].split(token);
			if( entries == null ){
				System.out.println( "String is not tokenized" );
				return ;
			}
			
			//Table = new Hashtable<String, String>();
			//Runs.add(Table);
			
			for(int i = 0; i < entries.length; i++ )
			{
				String tmp = entries[i];
				String [] kv = tmp.split(tokenKeyValue);
				if( kv == null || kv.length != 2 || kv[0] == null || kv[1] == null ){
					
					return ;
				}
			
				if( !(kv[0].length() == 0) && !(kv[1].trim().length() == 0) )
				{
					String [] vals = kv[1].split(tokenValuePlus);
					if (vals.length < 1) 
						return;
//						System.out.println("for debugging:"+url[0]);
					url[0] = url[0] + "?" +kv[0]+"="+vals[0];
					String rulename = (String)ruleURLMap.get(url[0].trim());
					//System.out.println("URL formed"+url[0]);
					if(rulename != null) {
					if(ruleCountMap.containsKey(rulename)) {
						int temp = (Integer)ruleCountMap.get(rulename);
						ruleCountMap.put(rulename, temp+1);
					}
					else
						ruleCountMap.put(rulename, 1);
					}
				}
			}
		}
		findCurrentPage();
		SetKeyValuePairs();
	}
	

	public void OldParse(String reqData) throws Exception
	{
		LocalTable.clear();
//		System.out.println( "Parsing request string" );

		if( reqData == null ){
			throw new Exception("Request string cannot be null");
		}

		if( reqData.trim() == "" ){
			return;
		}
		
		String [] entries = reqData.split(token);
		if( entries == null ){
			System.out.println( "String is not tokenized" );
		}

		Table = new Hashtable<String, String>();
		Runs.add(Table);
		
		for(int i = 0; i < entries.length; i++ )
		{
//			System.out.println( "Parsing request entries " +  entries[i] );

			String tmp = entries[i];
			String [] kv = tmp.split(tokenKeyValue);
			if( kv == null || kv.length != 2 || kv[0] == null || kv[1] == null ){
				return;
			}
		
			if( !(kv[0].length() == 0) && !(kv[1].trim().length() == 0) )
			{
				String [] vals = kv[1].split(tokenValuePlus);
				for(int v = 0; v < vals.length; v++ ){
					if( vals[v] !=null && !(vals[v].trim().length() == 0) )
					{
						LocalTable.put(kv[0], vals[v]);
//						AddUniqueKeyValue(kv[0], vals[v]);
//						Table.put(kv[0], vals[v]);
//						System.out.println( "Input parameter: " + kv[0] + ", value: " + vals[v] );
					}
				}
			}
		}

		findCurrentPage();
		SetKeyValuePairs();
	}

	private void SetKeyValuePairs() throws Exception {
		Set s = LocalTable.entrySet();
		Iterator i = s.iterator();
		while(i.hasNext())
		{
			Map.Entry m=(Map.Entry)i.next();
			String key = (String)m.getKey();
			String value=(String)m.getValue();

			if( key != null && key.toLowerCase().endsWith("unselected") ){
				key = key.toLowerCase();
				int ind = key.indexOf("unselected");
				key = key.substring(0, ind);
			}

			if( currentPage != null )
			{
				AddScreenInputValueMap(currentPage, key, value);
				key = currentPage + "." + key;
			}
			AddUniqueKeyValue(key, value);
			Table.put(key, value);
		}			
	}

	private void findCurrentPage()
	{
		currentPage = null;
		Set s = LocalTable.entrySet();
		Iterator i = s.iterator();

		while(i.hasNext())
		{
			Map.Entry m=(Map.Entry)i.next();

			String key = (String)m.getKey();
			String value=(String)m.getValue();
			
			if( key != null && key.equals(currentPageName) ){
				currentPage = value;
//				System.out.println( "Current page: " + currentPage ); hide_focus
				return;
			}
		}
	}
}
