package forepost;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.LinkedList;
import java.util.logging.Level;

import org.apache.jmeter.JMeter;

public class nonGUI implements Runnable
{
	ProfileAnalyzer analyzer = null;
	private boolean autocluster = false;
	private boolean isLearn = false;
	
	public nonGUI(ProfileAnalyzer pp) throws Exception{
		if( pp == null ) throw new Exception("the analyzer object is null");
		analyzer = pp;
	}
	@Override
	
	public void run() {
		// TODO Auto-generated method stub
		System.out.println("Start the nonGUI!");
		if( analyzer == null) {
			try {
				FPUtility.getLogger().log(Level.SEVERE, "Analyzer object is null");
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return;
		}
		new Thread(analyzer).start();
		
		int numOfProfiles = 0;
		
		for (;;){
			
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

			if (numOfProfiles != analyzer.numP) {
				numOfProfiles = analyzer.numP;
				System.out.println("The no. profiles is:" + numOfProfiles);
				isLearn = true;
			}
			
			if ((numOfProfiles%10 == 0) && (isLearn)) {
				System.out.println("10 PROFILES!");
				try {
					autocluster = true;
					analyzer.getClasses().clear();
					int total = numOfProfiles; //profileTableModel.getDataVector().size();
					LinkedList<String> classes = new LinkedList<String>();
					classes.add("Good");
					classes.add("Bad");
					//classes.add("Unassigned");
					analyzer.setClasses(classes);
		
					double averageTime = analyzer.GetElapsedTime() / total ;
					for(int i = 0; i < total; i++){
						analyzer.AssignClasses(averageTime, i);
					}
					System.out.println("AssignClasses!!");
					 
					 FPUtility.RuleLog("Enumerating classes for " + String.valueOf(numOfProfiles) + " profiles" );
		//			 logger.info("start learn rules!"); //QI
					 for( int i = 0; i < numOfProfiles; i++ ){
						 try {
							 FPUtility.RuleLog("Profile " + String.valueOf(i+1) + " : " + "time = " + String.valueOf(analyzer.profiles.get(i).GetElapsedTime()) + 
									 "\nmethods = " + String.valueOf(analyzer.profiles.get(i).GetMethods())  + 
									 "\ninvoked = " + String.valueOf(analyzer.profiles.get(i).GetInvocations())  +
									 "\nattributes = " + String.valueOf(analyzer.profiles.get(i).GetAttributes()) +
									 "\nKb = " + String.valueOf(analyzer.profiles.get(i).GetDatalen())  +
									 "\nclass = " + String.valueOf(analyzer.profiles.get(i).getProfileClass()) );
							//this.getAnalyzer().SetProfileClass(String.valueOf(profileTableModel.getValueAt(i, 6)), i);
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
		//				 System.out.println(profileTableModel.getValueAt(i, 6));
					 }
					 
					 try {
						 if(autocluster) 
							 analyzer.Analyze(true, numOfProfiles, FPUtility.getARFFRecalculateFlag());
						 else
							 analyzer.Analyze(false, numOfProfiles, FPUtility.getARFFRecalculateFlag());
						} catch (Exception e) {
							e.printStackTrace();
						}
						try {
							analyzer.numOfRules ++;
							File fileRules = new File("C:\\Research\\workspace_AFOCMS\\JMeterScript\\Results\\rules_" + analyzer.numOfRules); // Rules
							ObjectOutputStream oosRules = new ObjectOutputStream(new FileOutputStream(fileRules));
							oosRules.writeObject(JMeter.rules);
							oosRules.close();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}		
					
						analyzer.analyzeICA();
					
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				isLearn = false;
				if (analyzer.numOfRules >= 4) {
					System.out.println("Stop the system !!!");
				}
			}// end if
			

		}//end for
		
	} //end run

}
