package forepost.utilities;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.NoSuchElementException;

public class Rule implements Iterable<Term>, Iterator<Term>, Serializable
{
	String ruleText = null;
	private ArrayList<Term> Terms = new ArrayList<Term>();
	private String Class = null;
	
	public ArrayList<Term> getTerms() {
		return Terms;
	}

	public void setTerms(ArrayList<Term> terms) {
		Terms = terms;
	}

	public String getRuleText() {
		return ruleText;
	}

	public void setRuleText(String ruleText) {
		this.ruleText = ruleText;
	}
	
	public String GetRuleClass() {
		return Class;
	}

	public void SetClass(String class1) {
		Class = class1;
	}

	private int current = 0;
	
	public Rule() {
		super();
		Terms.clear();
	}
	
	public Rule (Term term) {
		AddTerm(term);
	}
	
	public void ResetTerms(){
		Terms.clear();
	}
	
	public int GetTotalTerms(){
		return( Terms.size() );
	}
	
	public Iterator<Term> iterator() {
		current = 0;
		return this;
	}

	public boolean hasNext() {
		return current < Terms.size();
	}

	public Term next() {
		if( current >= Terms.size() )
			throw new NoSuchElementException();
		return Terms.get(current++);
	}

	public void remove() {
		if( current > Terms.size() || current <= 0 )
			throw new NoSuchElementException();
		Terms.remove(current-1);
	}

	public void AddTerm(Term term) {
		Terms.add(term);
	}
}
