package forepost.utilities;

import java.util.HashMap;
import java.util.Map;

public class RuleTable {
	
	private Map <String, Rules> ruleTable = new HashMap<String, Rules> ();

	public Map<String, Rules> getRuleTable() {
		return ruleTable;
	}

	public void setRuleTable(Map<String, Rules> ruleTable) {
		this.ruleTable = ruleTable;
	}
	
	public void addRule(String widgetName, Rule rule) {
		if (rule != null && widgetName != null) {
			if (ruleTable.containsKey(widgetName)) {
				Rules rules = ruleTable.get(widgetName);
				while (rules.hasNext()) {
					if (rules.next().equals(rule)) {
						return;
					}
				}
				ruleTable.get(widgetName).AddRule(rule);
			} else {
				ruleTable.put(widgetName, new Rules(rule));
			}
		}
	}

	public void removeRule(String widgetName, Rule rule) {
		if (rule != null && widgetName != null) {
			if (ruleTable.containsKey(widgetName)) {
				Rules rules = ruleTable.get(widgetName);
				while (rules.hasNext()) {
					if (rules.next().equals(rule)) {
						rules.remove();
						break;
					}
				}
			}
		} 
	}
	
	public void removeEntry(String widgetName) {
		if (widgetName != null) {
			ruleTable.remove(widgetName);
		}
	}
	
	public static void main(String[] args) {
//		Term rule = new Term(Term.RELOPERATION.GREATER, "CustomersSO.numberResidents", "2", "good");
//		RuleTable table = new RuleTable();
//		table.addRule("CustomerSO.numberResidents", rule);
//		table.addRule("CustomerSO.numberResidents", rule);
//		rule = new Term(Term.RELOPERATION.LESS, "CustomersSO.numberResidents", "3", "good");
//		table.addRule("CustomerSO.numberResidents", rule);
//		table.removeRule("CustomerSO.numberResidents", rule);
//		rule = new Term(Term.RELOPERATION.LESS, "Customers.numberResidents", "3", "good");
//		table.addRule("Customers.numberResidents", rule);
//		table.removeEntry("CustomerSO.numberResidents");
	}
}
