package forepost.utilities;

import java.util.ArrayList;
import java.util.List;

public class ScreenInputData {
	enum Types {LIST, TEXTBOX, BUTTON};

	private String screenName;
	private List<InputData> inputs;
	
	public ScreenInputData() {
		inputs = new ArrayList<InputData> ();
	}
	
	public List<InputData> getInputs() {
		return inputs;
	}
	
	public void setInputs(List<InputData> inputs) {
		this.inputs = inputs;
	}
	
	public void addInput(InputData input) {
		inputs.add(input);
	}
	
	public String getScreenName() {
		return screenName;
	}
	
	public void setScreenName(String screenName) {
		this.screenName = screenName;
	}
	
	public class InputData {
		private String name_;
		private String type_;
		private List<String> values_;
		
		public InputData() {
			values_ = new ArrayList<String> ();
		}
		
		public InputData(String name, String type, List<String> values ) {
			name_ = name;
			type_ = type;
			values_ = values;
		}
		
		public InputData (InputData input) {
			name_ = input.getName();
		}

		public String getName() {
			return name_;
		}

		public void setName(String name_) {
			this.name_ = name_;
		}

		public String getType() {
			return type_;
		}

		public void setType(String type_) {
			this.type_ = type_;
		}

		public List<String> getValues() {
			return values_;
		}

		public void setValues(List<String> values_) {
			this.values_ = values_;
		}
		
		public void addValue(String value) {
			values_.add(value);
		}
	}
}
