package forepost.utilities;

import java.io.Serializable;

public class Term implements Serializable
{
	public static enum RELOPERATION {NOOP, NOTEQUAL, LESS, EQUAL, LEQ, GREATER, GEQ };
	public static enum VALUETYPE {INTVAL, STRINGVAL, REALVAL };
	
	private RELOPERATION rop = RELOPERATION.NOOP;
	private VALUETYPE valueType;
	private String inputName;
	private int intValue;
	private float realValue;
	private String strValue = null;
	
	public Term(){
		
	}
	
	public Term(RELOPERATION rop, String inputName, String Value ){
		this.rop = rop;
		this.inputName = inputName;
		try {
			strValue = Value;
			intValue = Integer.parseInt(Value);
			valueType = VALUETYPE.INTVAL;
		} catch( NumberFormatException e ){
			try {
				realValue = Float.parseFloat(Value);
				valueType = VALUETYPE.REALVAL;
			} catch( NumberFormatException ex ){
				strValue = Value;
				valueType = VALUETYPE.STRINGVAL;
			}
		}
	}
	
	public Term(Term rule){
		rop = rule.rop;
		inputName = rule.inputName;
		strValue = rule.strValue;
		valueType = rule.valueType;
	}

	public RELOPERATION getRop() {
		return rop;
	}

	public void setRop(RELOPERATION rop) {
		this.rop = rop;
	}

	public VALUETYPE getValueType() {
		return valueType;
	}

	public void setValueType(VALUETYPE valueType) {
		this.valueType = valueType;
	}

	public String getInputName() {
		return inputName;
	}

	public void setInputName(String inputName) {
		this.inputName = inputName;
	}

	public int getIntValue() {
		return intValue;
	}

	public void setValue(int intValue) {
		this.intValue = intValue;
	}

	public String getStrValue() {
		return strValue;
	}

	public void setValue(String strValue) {
		this.strValue = strValue;
	}
	
	public String getValue() {
		if (valueType == VALUETYPE.STRINGVAL)
			return strValue;
		else if (valueType == VALUETYPE.INTVAL)
			return Integer.toString(intValue);
		else 
			return Float.toString(realValue);
	}
	
	public String toString() {
		String output = "{" + inputName + "||" + rop.toString() + "||" + strValue + "}"; 
		return output;
	}
}
