package org.apache.jmeter;

import org.apache.jmeter.config.Argument;
import org.apache.jmeter.config.Arguments;
import org.apache.jmeter.control.LoopController;
import org.apache.jmeter.protocol.http.sampler.HTTPSampler;
import org.apache.jmeter.protocol.http.sampler.HTTPSamplerBase;
import org.apache.jmeter.save.ScriptWrapper;
import org.apache.jmeter.testelement.TestPlan;
import org.apache.jorphan.collections.HashTree;
import org.apache.jmeter.threads.AbstractThreadGroup;
import org.apache.jmeter.threads.ThreadGroup;

import com.accenture.techlabs.assist.profile.ProfRepository;

public class JMXLoadScript {
	
	public static final String JMETER_NON_GUI = "JMeter.NonGui";
	public static HashTree loadTree() {
		ScriptWrapper jmeterTestPlan = new ScriptWrapper();
		jmeterTestPlan.testPlan = new HashTree();
		TestPlan testPlan = new TestPlan();
		testPlan.setFunctionalMode(false);
		testPlan.setSerialized(false);
		ThreadGroup threadGroup = new ThreadGroup();
		LoopController lc = new LoopController();
		lc.setLoops(5);
		lc.setContinueForever(true);
		threadGroup.setSamplerController(lc);
		threadGroup.setNumThreads(5);
		threadGroup.setRampUp(1);
		AbstractThreadGroup.ON_SAMPLE_ERROR = "continue";
		HashTree htree = new HashTree();
		for(int i = 0; i< 10; i++)
			htree.add(createHttpSampler());
		HashTree htree1 = new HashTree();
		htree1.add(threadGroup,htree);
		jmeterTestPlan.testPlan.add(testPlan,htree1);
		return jmeterTestPlan.testPlan;
	}
	private static HTTPSampler createHttpSampler() {
		Argument argument = new Argument();
		argument.setName("categoryId");
		argument.setValue("FISH");
		argument.setMetaData("=");
		Arguments arguments= new Arguments();
		arguments.addArgument(argument);
		HTTPSampler sampler = new HTTPSampler();
		sampler.setDomain("localhost");
		sampler.setPort(8080);
		sampler.setPath("/JPetStoreApp/shop/viewCategory.shtml");
		sampler.setMethod("GET");
		sampler.setFollowRedirects(true);
		sampler.setAutoRedirects(false);
		sampler.setUseKeepAlive(true);
		HTTPSamplerBase.DO_MULTIPART_POST = "false";
		sampler.setMonitor(false);
		sampler.setArguments(arguments);
		return sampler;
	}

}
